P4568 [JLOI2011]飞行路线 && 分层图最短路板子

目录说:我在右边

什么是分层图最短路:

分层图最短路是指在可以进行分层图的图上解决最短路问题。
一般模型是:
在图上,有k次机会可以直接通过一条边(权值为0),问起点与终点之间的最短路径。

解决的一般思路:

以这个题为例,给出了k次可以免费通过一个点的机会,
我们可以把原来的图垒在一起;
ex:

k = 1
1 2 3
2 3 4
3 1 2
4 2 1
4 3 6

我们在建完图之后再加上图中权值为0的边,很明显的分成了两层(若k = 1).

如果上边的那一层走到了下边,那就说明用了一次免费的机会.
那么我们就可以在这个图中跑最短路了。
最后的答案就是每一个n,n‘,n‘‘ ... 中取一个最大值.

怎么建图:

用手建图

for (int i = 1, a, b, d; i <= m; i++) {
    a = read(), b = read(), d = read();
    add(a, b, d), add(b, a, d);//在原图上连边
    for (int j = 1; j <= k; j++) {
        add(a + (j - 1) * n, b + j * n, 0);//两层之间的连一条无边权的边
        add(b + (j - 1) * n, a + j * n, 0);//如果走了那么说明用了一次免费机会
        add(a + j * n, b + j * n, d);//在每一层图上连边
    add(b + j * n, a + j * n, d);
    }
}

code

#include <bits/stdc++.h>

#define N 110010
#define M 2100010
#define ll long long

using namespace std;
const int inf = 2147483647;
int n, m, k, s, t; bool vis[N];
int head[N], add_edge, dis[N];
struct qaq {
    int next, to, dis;
}edge[M];
struct node {
    int point, dist;
    bool operator < (const node &b) const {
        return dist > b.dist;
    }
}; 

int read() {
    int s = 0, f = 0; char ch = getchar();
    while (!isdigit(ch)) f |= (ch == '-'), ch = getchar();
    while (isdigit(ch)) s = s * 10 + (ch ^ 48), ch = getchar();
    return f ? -s : s;
}

void add(int from, int to, int dis) {
    edge[++add_edge].next = head[from];
    edge[add_edge].dis = dis;
    edge[add_edge].to = to;
    head[from] = add_edge;
}

void dijkstra(int s) {
    memset(dis, 127, sizeof dis);
    dis[s] = 0;
    priority_queue<node> q;
    q.push((node){s, 0});
    while (!q.empty()) {
        node fr = q.top(); q.pop();
        int x = fr.point;
        if (vis[x]) continue;
        vis[x] = 1;
        for (int i = head[x]; i; i = edge[i].next) {
            int to = edge[i].to;
            if (!vis[to] && dis[to] > dis[x] + edge[i].dis) {
                dis[to] = dis[x] + edge[i].dis;
                q.push((node){to, dis[to]});
            }
        }
    }
}

void add_work() {
    s = read(), t = read();
    for (int i = 1, a, b, d; i <= m; i++) {
        a = read(), b = read(), d = read();
        add(a, b, d), add(b, a, d);
        for (int j = 1; j <= k; j++) {
            add(a + (j - 1) * n, b + j * n, 0);
            add(b + (j - 1) * n, a + j * n, 0);
            add(a + j * n, b + j * n, d);
            add(b + j * n, a + j * n, d);
        }
    }
    dijkstra(s);
}

int main() {
    n = read(), m = read(), k = read();
    add_work();
    int ans = inf;
    for (int i = t; i <= n * (k + 1); i += n)
        ans = min(ans, dis[i]);
    cout << ans;
}                   

注意事项

  • spfa:我死了
  • 注意算好空间开的范围

    这个题边集是\(500000\)的,\(K\)最多是\(10\),原图加两条边,其它层的图及层之间会加4条边,
    每次最多加\(42\)条边,所以边集要开到\((4?10+2)?50000=2100000\)
    每层图要多开\(n\)个点,所以点集是\(10000+10000?10=110000\)的,注意都\(+10\)

原文地址:https://www.cnblogs.com/zzz-hhh/p/12183183.html

时间: 2024-10-06 20:42:10

P4568 [JLOI2011]飞行路线 && 分层图最短路板子的相关文章

[P4568][JLOI2011] 飞行路线 (分层图+最短路)

题意:有n个城市,m条航线,每条航线都有一个权值,并且还多了k次免费航行的机会,求1~n的最短路: 做法:分层图+最短路: 1.分层图:因为多了k次免费航行,所以可以考虑建出k+1个图,然后跑一遍最短路: 2.最短路:既然能写分层图,那么最短路应该都会了吧,可以用 dijkstra 或 SPFA : 附上代码: #include<cstdio> #include<cstring> #include<iostream> #include<algorithm>

BZOJ2763[JLOI2011]飞行路线 [分层图最短路]

2763: [JLOI2011]飞行路线 Time Limit: 10 Sec  Memory Limit: 128 MBSubmit: 2523  Solved: 946[Submit][Status][Discuss] Description Alice和Bob现在要乘飞机旅行,他们选择了一家相对便宜的航空公司.该航空公司一共在n个城市设有业务,设这些城市分别标记为0到n-1,一共有m种航线,每种航线连接两个城市,并且航线有一定的价格.Alice和Bob现在要从一个城市沿着航线到达另一个城市

P4568 飞行路线 分层图最短路

P4568 飞行路线 分层图最短路 分层图最短路 问题模型 求最短路时,可有\(k\)次更改边权(减为0) 思路 在普通求\(Dijkstra\)基础上,\(dis[x][j]\)多开一维\(j\)以存已用了多少次机会,然后每次松弛时,做完普通松弛操作后,还要使用一次机会(如果可以),类同\(DP\). 每次普通松弛: \[ dis[to][j]=min\{dis[cur][j], dis[to][j]\} \] 如果还可以使用(\(j<k\)): \[ dis[to][j+1] = min\{

bzoj2763: [JLOI2011]飞行路线(分层图spfa)

2763: [JLOI2011]飞行路线 Time Limit: 10 Sec  Memory Limit: 128 MBSubmit: 3234  Solved: 1235[Submit][Status][Discuss] Description Alice和Bob现在要乘飞机旅行,他们选择了一家相对便宜的航空公司.该航空公司一共在n个城市设有业务,设这些城市分别标记为0到n-1,一共有m种航线,每种航线连接两个城市,并且航线有一定的价格.Alice和Bob现在要从一个城市沿着航线到达另一个城

BZOJ 2763 JLOI 2011 飞行路线 分层图+最短路

题目大意:两个小屁孩要乘飞机去旅行.现在给一些无向边和边权,另外他们还有K次免费乘坐飞机的机会,问从起点到终点的最小话费是什么. 思路:分层图第一题.之前听到分层图还以为是真的建K个图,然后不同层数之间的点连边跑最短路..后来经同学讲解才发现我想多了.. 其实还是动归的思想(最短路不也是动归的思想么(`?ω?′)),f[ i ][ j ]表示在j位置时,已经用了i次免费机会的时候的最小花费,然后在SPFA里多一维的转移就可以了. PS:BZOJ上这个题还是挺卡常数的,我之前用queue用了938

bzoj 2763 [JLOI2011]飞行路线——分层图

题目:https://www.lydsy.com/JudgeOnline/problem.php?id=2763 分层图两种方法的练习. 1.把图分成k+1层,本层去上面一层的边免费.但空间时间都不算优秀. #include<iostream> #include<cstdio> #include<cstring> #include<queue> #define ll long long using namespace std; const int N=1e4

bzoj2763: [JLOI2011]飞行路线 分层图+dij+heap

分析:d[i][j]代表从起点到点j,用了i次免费机会,那就可以最短路求解 #include <stdio.h> #include <iostream> #include <algorithm> #include <vector> #include <queue> #include <string.h> using namespace std; typedef long long LL; const int INF=0x3f3f3f3

bzoj 2763: [JLOI2011]飞行路线 分层图

题目链接 n个点m条路, 每条路有权值,  给出起点和终点, 求一条路使得权值最小.可以使路过的路中, k条路的权值忽略. 其实就是多一维, 具体看代码 #include<bits/stdc++.h> using namespace std; #define pb(x) push_back(x) #define ll long long #define mk(x, y) make_pair(x, y) #define lson l, m, rt<<1 #define mem(a)

「JLOI2011」「LuoguP4568」飞行路线(分层图最短路

题目描述 Alice和Bob现在要乘飞机旅行,他们选择了一家相对便宜的航空公司.该航空公司一共在nn个城市设有业务,设这些城市分别标记为00到n-1n−1,一共有mm种航线,每种航线连接两个城市,并且航线有一定的价格. Alice和Bob现在要从一个城市沿着航线到达另一个城市,途中可以进行转机.航空公司对他们这次旅行也推出优惠,他们可以免费在最多kk种航线上搭乘飞机.那么Alice和Bob这次出行最少花费多少? 输入输出格式 输入格式: 数据的第一行有三个整数,n,m,kn,m,k,分别表示城市